LibreOffice: Shape Service Reference

LibreOffice LibreOffice 7.3 SDK API Reference

Public Types | Exported Interfaces | Public Attributes | List of all members
Shape Service Referencepublished

This abstract service specifies the general characteristics of all Shapes. More...

`import"Shape.idl";`

Inheritance diagram for Shape:

## Public Types
typedef sequence< com::sun::star::beans::PropertyValue > | InteropGrabBag
| Grab bag of shape properties, used as a string-any map for interim interop purposes. More...

## Exported Interfaces
interface | com::sun::star::beans::XPropertySet
| handles all the properties of this instance. More...
interface | com::sun::star::drawing::XShape
| This gives you the size and position of this Shape and lets you change it. More...
interface | com::sun::star::lang::XComponent
| is used for lifetime control of this Shape. More...
interface | com::sun::star::drawing::XShapeDescriptor
| The XShapeDescriptor tells you what kind of Shape this instance is. More...
interface | com::sun::star::drawing::XGluePointsSupplier
| This interfaces gives access to an optional container of gluepoints. More...
interface | com::sun::star::beans::XTolerantMultiPropertySet

## Public Attributes
long | ZOrder
| is used to query or change the ZOrder of this Shape. More...
short | LayerID
| This is the ID of the Layer to which this Shape is attached. More...
string | LayerName
| This is the name of the Layer to which this Shape is attached. More...
boolean | Visible
| If this is `FALSE`, the Shape is not visible on screen outputs. More...
boolean | Printable
| If this is `FALSE`, the Shape is not visible on printer outputs. More...
boolean | MoveProtect
| With this set to `TRUE`, this Shape cannot be moved interactively in the user interface. More...
string | Name
| This is the name of this Shape. More...
boolean | SizeProtect
| With this set to `TRUE`, this Shape may not be sized interactively in the user interface. More...
com::sun::star::style::XStyle | Style
| this property lets you get and set a style for this shape. More...
com::sun::star::drawing::HomogenMatrix3 | Transformation
| this property lets you get and set the transformation matrix for this shape. More...
com::sun::star::container::XNameContainer | ShapeUserDefinedAttributes
| this property stores xml attributes. More...
long | NavigationOrder
| this property stores the navigation order of this shape. More...
string | Hyperlink
| this property lets you get and set a hyperlink for this shape. More...
short | RelativeHeight
| contains the relative height of the object. More...
short | RelativeWidth
| contains the relative width of the object. More...
short | RelativeHeightRelation
| contains the relation of the relative height of the object. More...
short | RelativeWidthRelation
| contains the relation of the relative width of the object. More...

## Additional Inherited Members
Public Member Functions inherited from XPropertySet
com::sun::star::beans::XPropertySetInfo | getPropertySetInfo ()
void | setPropertyValue ([in] string aPropertyName, [in] any aValue) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the value of the property with the specified name. More...
any | getPropertyValue ([in] string PropertyName) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
void | addPropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener xListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XPropertyChangeListener to the specified property. More...
void | removePropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XPropertyChangeListener from the listener list. More...
void | addVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XVetoableChangeListener to the specified property with the name PropertyName. More...
void | removeVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XVetoableChangeListener from the listener list. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XShape
com::sun::star::awt::Point | getPosition ()
| gets the current position of this object. More...
void | setPosition ([in] com::sun::star::awt::Point aPosition)
| sets the current position of this object More...
com::sun::star::awt::Size | getSize ()
| gets the size of this object. More...
void | setSize ([in] com::sun::star::awt::Size aSize) raises ( com::sun::star::beans::PropertyVetoException )
| sets the size of this object. More...
Public Member Functions inherited from XShapeDescriptor
string | getShapeType ()
Public Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references. More...
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object. More...
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list. More...
Protected Member Functions inherited from XGluePointsSupplier
com::sun::star::container::XIndexContainer | getGluePoints ()
Protected Member Functions inherited from XTolerantMultiPropertySet
sequence< com::sun::star::beans::SetPropertyTolerantFailed > | setPropertyValuesTolerant ([in] sequence< string > aPropertyNames, [in] sequence< any > aValues) raises ( com::sun::star::lang::IllegalArgumentException )
| sets the values to the properties with the specified names. More...
sequence< com::sun::star::beans::GetPropertyTolerantResult > | getPropertyValuesTolerant ([in] sequence< string > aPropertyNames)
| retrieve the values of the specified properties More...
sequence< com::sun::star::beans::GetDirectPropertyTolerantResult > | getDirectPropertyValuesTolerant ([in] sequence< string > aPropertyNames)
| retrieve only those values of the specified properties which are direct values. More...

## Detailed Description

This abstract service specifies the general characteristics of all Shapes.

See also
  XShape
  com::sun::star::lang::XComponent
  com::sun::star::text::XText
  ShapeDescriptor

Developers Guide
  Drawings - Shape Types

## Member Typedef Documentation

## ◆ InteropGrabBag

sequence<com::sun::star::beans::PropertyValue> InteropGrabBag
| optionalproperty

Grab bag of shape properties, used as a string-any map for interim interop purposes.

Since
  LibreOffice 4.2

This property is intentionally not handled by the ODF filter. Any member that should be handled there should be first moved out from this grab bag to a separate property.

## Exported Interfaces

## ◆ com::sun::star::beans::XPropertySet

interface com::sun::star::beans::XPropertySet

handles all the properties of this instance.

## ◆ com::sun::star::beans::XTolerantMultiPropertySet

interface com::sun::star::beans::XTolerantMultiPropertySet
| optional

## ◆ com::sun::star::drawing::XGluePointsSupplier

interface com::sun::star::drawing::XGluePointsSupplier
| optional

This interfaces gives access to an optional container of gluepoints.

To have unique ids you should query the returned interface for com::sun::star::container::XIdentifierContainer.

## ◆ com::sun::star::drawing::XShape

interface com::sun::star::drawing::XShape

This gives you the size and position of this Shape and lets you change it.

You can use getShapeType() to determine what kind of shape this is.

## ◆ com::sun::star::drawing::XShapeDescriptor

interface com::sun::star::drawing::XShapeDescriptor

The XShapeDescriptor tells you what kind of Shape this instance is.

## ◆ com::sun::star::lang::XComponent

interface com::sun::star::lang::XComponent

is used for lifetime control of this Shape.

## Member Data Documentation

## ◆ Hyperlink

string Hyperlink
| optionalproperty

this property lets you get and set a hyperlink for this shape.

## ◆ LayerID

short LayerID
| optionalproperty

This is the ID of the Layer to which this Shape is attached.

## ◆ LayerName

string LayerName
| optionalproperty

This is the name of the Layer to which this Shape is attached.

## ◆ MoveProtect

boolean MoveProtect
| optionalproperty

With this set to `TRUE`, this Shape cannot be moved interactively in the user interface.

## ◆ Name

string Name
| optionalproperty

This is the name of this Shape.

## ◆ NavigationOrder

long NavigationOrder
| optionalproperty

this property stores the navigation order of this shape.

If this value is negative, the navigation order for this shapes page is equal to the z-order.

## ◆ Printable

boolean Printable
| optionalproperty

If this is `FALSE`, the Shape is not visible on printer outputs.

## ◆ RelativeHeight

short RelativeHeight
| optionalproperty

contains the relative height of the object.

It is only valid if it is greater than zero.

Since
  LibreOffice 4.3

## ◆ RelativeHeightRelation

short RelativeHeightRelation
| optionalproperty

contains the relation of the relative height of the object.

It is only valid if RelativeHeight is greater than zero.

See also
  com::sun::star::text::RelOrientation

Since
  LibreOffice 4.3

## ◆ RelativeWidth

short RelativeWidth
| optionalproperty

contains the relative width of the object.

It is only valid if it is greater than zero.

Since
  LibreOffice 4.3

## ◆ RelativeWidthRelation

short RelativeWidthRelation
| optionalproperty

contains the relation of the relative width of the object.

It is only valid if RelativeWidth is greater than zero.

See also
  com::sun::star::text::RelOrientation

Since
  LibreOffice 4.3

## ◆ ShapeUserDefinedAttributes

com::sun::star::container::XNameContainer ShapeUserDefinedAttributes
| optionalproperty

this property stores xml attributes.

They will be saved to and restored from automatic styles inside xml files.

See also
  com::sun::star::xml::AttributeContainer

## ◆ SizeProtect

boolean SizeProtect
| optionalproperty

With this set to `TRUE`, this Shape may not be sized interactively in the user interface.

## ◆ Style

com::sun::star::style::XStyle Style
| optionalproperty

this property lets you get and set a style for this shape.

## ◆ Transformation

com::sun::star::drawing::HomogenMatrix3 Transformation
| optionalproperty

this property lets you get and set the transformation matrix for this shape.

The transformation is a 3x3 homogeneous matrix and can contain translation, rotation, shearing and scaling.

## ◆ Visible

boolean Visible
| optionalproperty

If this is `FALSE`, the Shape is not visible on screen outputs.

Please note that the Shape may still be visible when printed, see Printable.

## ◆ ZOrder

long ZOrder
| optionalproperty

is used to query or change the ZOrder of this Shape.

The documentation for this service was generated from the following file:

- com/sun/star/drawing/Shape.idl